* Last Update:  December 16, 1990,  11:42 PM
* Author:       Philip A. Smith
* Program:      FOXTSR.PRG
* Version:      FoxPro
*
* This is all the code that's required to turn any FoxPro application into a
* RAM resident program.
*
SET BELL OFF
SET TALK OFF
SET STATUS OFF
SET SCOREBOARD OFF
normal = 'BG/N'
SET COLOR TO &normal
CLEAR
errcolor = 'W+/R'
bell = CHR(7)
forever = .T.
LOAD FOXASE
DO TSR
*
* This takes you to DOS initially.
*
option = 6
@ 8,30 TO 16,48
@ 9,31 CLEAR TO 15,47
SET MESSAGE TO 24 CENTER
item1 = 'Select this item to add entries to the mailing list'
item2 = 'Select this option to change entries in the mailing list'
item3 = 'Select this option to remove entries from the mailing list'
item4 = 'Select this option to view entries in the mailing list'
item5 = 'Select this option to print labels'
item6 = 'Press [ENTER] or [ALT][F10] from any item for the suspended program'
item7 = 'Select this option to exit this application completely'
DO WHILE forever
*  [Your FoxPro code goes here, i.e. Main menu routine]
  @ 8,31 SAY ""
  @ ROW()+1,31 PROMPT " Add an entry    " MESSAGE item1
  @ ROW()+1,31 PROMPT " Change an entry " MESSAGE item2
  @ ROW()+1,31 PROMPT " Remove an entry " MESSAGE item3
  @ ROW()+1,31 PROMPT " View an entry   " MESSAGE item4
  @ ROW()+1,31 PROMPT " Print Labels    " MESSAGE item5
  @ ROW()+1,31 PROMPT " Exit To Program " MESSAGE item6
  @ ROW()+1,31 PROMPT " Quit and Unload " MESSAGE item7
  MENU TO option
  SAVE SCREEN TO mainscr1
  DO CASE
  CASE option = 1
  CASE option = 2
  CASE option = 3
  CASE option = 4
  CASE option = 5
  CASE option = 6
* Option 6 selected from the menu - Go back to what we popped up on.
    DO TSR
  CASE option = 7
* Say goodbye
* Say goodbye
    IF DRACTIVE()
      nul = DRKILL()
    ENDIF
    EXIT
  ENDCASE
  RESTORE SCREEN FROM mainscr1
ENDDO
RELEASE MODULE FOXASE
CLEAR
RETURN

PROCEDURE TSR
IF DRACTIVE()
* Go back to what we popped up on
  nul = DRSWAP()
ELSE
* Turn this app into a TSR
  ON KEY LABEL ALT-F10 DO TSR
********************************************************************
* Just exit to the DOS prompt.                                     *
* Swap to the C: drive.                                            *
* Free the maximum amount of RAM.                                  *
* Set up DRCLIP.BRD as the paste file.                             *
* Set ALT-INS as the paste key.                                    *
* Use the same key to suspend FoxPro and whatever may be running.  *
* Use any memory resource that's available.                        *
********************************************************************
  paste_file = "DRCLIP.BRD"
  paste_key = "{ALT}{INS}"
  paste_mode = 1
  command = ""
  drive_path = ""
  ram = 640
  hotkey = "{ALT}{F10}"
  ems = .T.
  xms = .T.
  SAVE SCREEN TO your_scr
  CLEAR
  @ 24,0 SAY "Press [Alt][F10] to pop up the Dr. Switch-ASE demo on top of any program."
  nul = AFFIX(paste_file,paste_key,paste_mode)
  nul = DRLOAD(command,drive_path,ram,hotkey,ems,xms)
  RESTORE SCREEN FROM your_scr
ENDIF
RETURN
*
FUNCTION DRLOAD
PARAMETERS ase_cmd, ase_drive, ase_ram, ase_hot, ase_ems, ase_xms
ase_call = "[ASE]L"
ase_call = ase_call + IIF(TYPE('ase_cmd') = 'C',"[COMMAND]"+LTRIM(TRIM(ase_cmd)),"")
ase_call = ase_call + IIF(TYPE('ase_drive') = 'C',"[DRIVE]"+LTRIM(TRIM(ase_drive)),"")
ase_call = ase_call + IIF(TYPE('ase_ram') = 'N',"[RAM]"+LTRIM(STR(ase_ram)),"")
ase_call = ase_call + IIF(TYPE('ase_hot') = 'C',"[HOTKEY]"+LTRIM(TRIM(ase_hot)),"")
ase_call = ase_call + IIF(TYPE('ase_ems') = 'L',"[EMS]"+IIF(ase_ems,'Y','N'),"")
ase_call = ase_call + IIF(TYPE('ase_xms') = 'L',"[XMS]"+IIF(ase_xms,'Y','N'),"")
CALL FOXASE WITH ase_call
RETURN(VAL(SUBSTR(ase_call,1,1)))
*
FUNCTION DRSWAP
PARAMETERS ase_cmd, ase_drive, ase_ram, ase_hot, ase_ems, ase_xms
ase_call = "[ASE]S"
ase_call = ase_call + IIF(TYPE('ase_cmd') = 'C',"[COMMAND]"+LTRIM(TRIM(ase_cmd)),"")
ase_call = ase_call + IIF(TYPE('ase_drive') = 'C',"[DRIVE]"+LTRIM(TRIM(ase_drive)),"")
ase_call = ase_call + IIF(TYPE('ase_ram') = 'N',"[RAM]"+LTRIM(STR(ase_ram)),"")
ase_call = ase_call + IIF(TYPE('ase_hot') = 'C',"[HOTKEY]"+LTRIM(TRIM(ase_hot)),"")
ase_call = ase_call + IIF(TYPE('ase_ems') = 'L',"[EMS]"+IIF(ase_ems,'Y','N'),"")
ase_call = ase_call + IIF(TYPE('ase_xms') = 'L',"[XMS]"+IIF(ase_xms,'Y','N'),"")
CALL FOXASE WITH ase_call
RETURN(VAL(SUBSTR(ase_call,1,1)))
*
FUNCTION DRACTIVE
ase_call = "[ASE]A"
CALL FOXASE WITH ase_call
RETURN(IIF(SUBSTR(ase_call,1,1)='Y',.T.,.F.))
*
FUNCTION AFFIX
PARAMETERS paste_file, paste_key, paste_mode
ase_call = "[ASE]P"
ase_call = ase_call + IIF(TYPE('paste_file') = 'C',"[FILE]"+LTRIM(TRIM(paste_file)),"")
ase_call = ase_call + IIF(TYPE('paste_key') = 'C',"[KEY]"+LTRIM(TRIM(paste_key)),"")
ase_call = ase_call + IIF(TYPE('paste_mode') = 'N',"[MODE]"+LTRIM(STR(paste_mode)),"")
CALL FOXASE WITH ase_call
RETURN(VAL(SUBSTR(ase_call,1,1)))
*
FUNCTION DRKILL
ase_call = "[ASE]K"
CALL FOXASE WITH ase_call
RETURN(IIF(SUBSTR(ase_call,1,1)='Y',.T.,.F.))
*
FUNCTION DRPLAY
ase_call = "[PLAY]Y"
CALL FOXASE WITH ase_call
RETURN(IIF(SUBSTR(ase_call,1,1)='Y',.T.,.F.))
*
FUNCTION DRCUT
PARAMETERS cut_file, cut_key, cut_mode
ase_call = "[ASE]C"
ase_call = ase_call + IIF(TYPE('cut_file') = 'C',"[FILE]"+LTRIM(TRIM(cut_file)),"")
ase_call = ase_call + IIF(TYPE('cut_key') = 'C',"[KEY]"+LTRIM(TRIM(cut_key)),"")
ase_call = ase_call + IIF(TYPE('cut_mode') = 'N',"[MODE]"+LTRIM(STR(cut_mode)),"")
CALL FOXASE WITH ase_call
RETURN(VAL(SUBSTR(ase_call,1,1)))
*
